(* $Id: main.ml,v 1.4 2006-11-10 20:47:35 deraugla Exp $ *)

open Stdpp;

value print_version () = (
  Printf.eprintf "Budget version 1.1\n";
  flush Pervasives.stderr;
  exit 0
);

value main () = (
  Arg.parse [("-v", Arg.Unit print_version, "print version")]
    (fun s -> File.source.val := s) "Usage: budget [-v] [source]";
  Budget.go ""
);

Printexc.catch
  (fun () ->
     try main () with
     [ Exc_located _ exc -> (
         Printf.printf "At some location...\n";
         flush Pervasives.stdout;
         raise exc
       )
     | exc -> raise exc ])
  ()
;
